/*******************************************************************************
 *                                      *                                      *
 *    HOLDUP BV                         *    STOGGER BV                        *
 *    Nachtegaalstraat 8                *    Haagveld 1A                       *
 *    5988 NG  Helden                   *    5981 PK  Panningen                *
 *    The Netherlands                   *    The Netherlands                   *
 *                                      *                                      *
 *******************************************************************************
 *                                      *                                      *
 *    Aubert Dupont                     *                                      *
 *    aubert@holdup.nl                  *                                      *
 *                                      *                                      *
 *******************************************************************************
 *                                                                             *
 *    Project    -   STOGGER - E-41-2000 - Ventilator PAL                      *
 *    Author     -   Aubert Dupont                                             *
 *    Build Tool -   MPLAB X IDE v4.15 & MPLAB XC8 v1.45                       *
 *    Revision   -   1.01                                                      *
 *    Date       -   2020-04-01                                                *
 *    Function   -   System definition file                                    *
 *    File       -   system.h                                                  *
 *                                                                             *
 *******************************************************************************
 *                                                                             *
 *    (C)  2020  HOLDUP BV         ALL RIGHTS RESERVED                         *
 *    (C)  2020  STOGGER BV        ALL RIGHTS RESERVED                         *
 *                                                                             *
 ******************************************************************************/

/*******************************************************************************
 *
 *   Documentation / Functional description
 *
 *******************************************************************************
 *
 ******************************************************************************/

/*******************************************************************************
 ** Macro defintions
 ******************************************************************************/

#define SelectEEPROM()                 (EECON1bits.EEPGD = 0)

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */

#define SerialRxOn()                   (RCSTAbits.CREN = 1)
#define SerialRxOff()                  (RCSTAbits.CREN = 0)
#define SerialRxFrameValid()           (RCSTAbits.FERR == 0)
#define SerialRxFrameError()           (RCSTAbits.FERR == 1)
#define SerialRxBufferValid()          (RCSTAbits.OERR == 0)
#define SerialRxBufferError()          (RCSTAbits.OERR == 1)
#define SerialRxReady()                (PIR1bits.RCIF == 1)
#define SerialRxChar()                 (RCREG)

/* -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  */

#define SerialTxOn()                   (TXSTAbits.TXEN = 1)
#define SerialTxOff()                  (TXSTAbits.TXEN = 0)
#define SerialTxReady()                (TXSTAbits.TRMT == 1)

/*******************************************************************************
 ** System Function Prototypes
 ******************************************************************************/

void ConfigureOscillator (void);
void ConfigureWatchdog (void);
void ConfigurePorts (void);
void ConfigurePeripherals (void);

/******************************************************************************/

void SerialTxChar (uint8_t _Char);

/******************************************************************************/

uint16_t FlashRead (uint16_t _Address);
enum RETURN FlashErase (uint16_t _Address);
enum RETURN FlashWrite (uint16_t _Address, uint16_t* _Data, uint8_t _Words);

/*******************************************************************************
 ** END-O-HEADER
 ******************************************************************************/
