#!/bin/bash
#
# Generate Firmware Flash file for Stogger Boot Loader, usage:
#
#  $1 = source file
#  $2 = destination file
#
# Written by Aubert Dupont
#
# Version 1.0 - 2020-04-03 - initial release
#

# Check the parameter
[ ! -n "$1" ] && exit 1

# Setup variables
DATE=$(date +"%Y-%m-%d %H:%M")

# Create destination file header
echo "# ==========================================" > "$2"
echo "# Firmware $2" >> "$2"
echo "# Created on $DATE" >> "$2"
echo "# STOGGER (C) 2016-2020" >> "$2"
echo "# Do not edit this file!" >> "$2"
echo "# ==========================================" >> "$2"

# Open source HEX file and parse it
grep -v "FF3FFF3FFF3FFF3FFF3FFF3FFF3FFF3F" "$1" | grep -v ":02"  | grep -v ":04"  | grep -v ":000000" | while read -r LINE
do
  echo "$LINE;" >> "$2"
done

# Add final firmware check
echo "# ==========================================" >> "$2"
echo "" >> "$2"

# Exit w/o error code
exit 0

